/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 955 $ $LastChangedDate: 2002-09-13 09:42:43 +0200 (Fri, 13 Sep 2002) $
 *
 * Standard library for Gont, Stack module interface.
 *
 * Mutable stack.
 */

type <'a>t;

// raise Invalid_argument if empty
'a pop(<'a>t);
'a top(<'a>t);
void push(<'a>t, 'a);
<'a>t create();
bool empty(<'a>t);
<'a>list to_list(<'a>t);
