// Test basic unions
// $Rev: 930 $ $LastChangedDate: 2002-09-11 09:36:02 +0200 (Wed, 11 Sep 2002) $

def print_int(x) (puts(itoa(x)))
union foo {
	int Int;
	string String;
	*(int, int) Int2;
	*(foo, foo) Foo2;
}

void print_foo(foo x)
{
	switch x {
	case String(s):
		puts(s);
	case Int(i):
		print_int(i);
	case Int2(u, v):
		puts("(");
		print_int(u);
		puts(",");
		print_int(v);
		puts(")");
	case Foo2(u, v):
		puts("(");
		print_foo(u);
		print_foo(v); 
		puts(")");
	}

	puts(" ");
}

section init
{
	print_foo(String("foo"));
	print_foo(Int(10));
	print_foo(Int2(10, 20));
	print_foo(Foo2(Foo2(Int(10), String("bar")), Int2(20,30)));
	puts(".\n");
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: foo 10 (10,20) ((10 bar ) (20,30) ) .
 */
