#ifndef BISON_PARSER_TAB_H
# define BISON_PARSER_TAB_H

# ifndef YYSTYPE
#  define YYSTYPE int
#  define YYSTYPE_IS_TRIVIAL 1
# endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;

  int last_line;
  int last_column;
} yyltype;

# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

# define	INT	257
# define	FLOAT	258
# define	ID	259
# define	STRING	260
# define	TYVAR	261
# define	CHAR	262
# define	LEX_ERROR	263
# define	KW_AS	264
# define	KW_BOOL	265
# define	KW_BREAK	266
# define	KW_CASE	267
# define	KW_CLASS	268
# define	KW_CONTINUE	269
# define	KW_DEF	270
# define	KW_DO	271
# define	KW_ELSE	272
# define	KW_EXCEPTION	273
# define	KW_EXTERN	274
# define	KW_FALSE	275
# define	KW_FINALLY	276
# define	KW_FLOAT	277
# define	KW_FOR	278
# define	KW_FUN	279
# define	KW_IF	280
# define	KW_IN	281
# define	KW_INT	282
# define	KW_LET	283
# define	KW_NAMESPACE	284
# define	KW_NEW	285
# define	KW_NULL	286
# define	KW_OBJECT	287
# define	KW_OPEN	288
# define	KW_OPT_STRUCT	289
# define	KW_PRIVATE	290
# define	KW_PROTECTED	291
# define	KW_RAISE	292
# define	KW_RETURN	293
# define	KW_SECTION	294
# define	KW_SKIP	295
# define	KW_STRING	296
# define	KW_STRUCT	297
# define	KW_SWITCH	298
# define	KW_THIS	299
# define	KW_TRUE	300
# define	KW_TRY	301
# define	KW_TYPE	302
# define	KW_TYPEDEF	303
# define	KW_UNION	304
# define	KW_VIRTUAL	305
# define	KW_VOID	306
# define	KW_WHILE	307
# define	KW_WITH	308
# define	AND_AND	309
# define	OR_OR	310
# define	ARROW	311
# define	GTGT	312
# define	LTLT	313
# define	DOUBLECOLON	314
# define	EQ	315
# define	NE	316
# define	GE	317
# define	LE	318
# define	MINUS_EQUAL	319
# define	PERCENT_EQUAL	320
# define	PLUS_EQUAL	321
# define	SLASH_EQUAL	322
# define	STAR_EQUAL	323
# define	AND_EQUAL	324
# define	OR_EQUAL	325
# define	XOR_EQUAL	326
# define	LTLT_EQUAL	327
# define	GTGT_EQUAL	328
# define	MINUS_MINUS	329
# define	PLUS_PLUS	330
# define	UMINUS	331


extern YYSTYPE yylval;

#endif /* not BISON_PARSER_TAB_H */
